:- [util],[ziehen],[bieten].

eine_neue_burg(Spielfeld,Farbe1,Feld1,Farbe2,Feld2,Farbe3,Feld3,Schritte) :-
	member(phase(3),Spielfeld),
	aktueller_spieler(Spieler,Spielfeld),
	member(spieler(_,Spieler,BurgenVorher),Spielfeld),
	teste_reserve(Spieler,Farbe1,Spielfeld),
	ritter_auf_feld_legen(Farbe1,Feld1,Spielfeld,Spielfeld2),
	kleinergleichFarbe(Farbe2,Farbe1),
	ritter_auf_feld_legen(Farbe2,Feld2,Spielfeld2,Spielfeld3),
	kleinergleichFarbe(Farbe3,Farbe2),
	ritter_auf_feld_legen(Farbe3,Feld3,Spielfeld3,Spielfeld4),
	kaiser_bewegen(Schritte,Spielfeld4,Spielfeld5),
	burgen_tausch(Spielfeld5,Spielfeld6),
	member(spieler(_,Spieler,BurgenNachher),Spielfeld6),
	BurgenVorher > BurgenNachher.

eine_neue_burg(Spielfeld,Farbe1,Feld1,Farbe2,Feld2,Schritte) :-
	member(phase(3),Spielfeld),
	aktueller_spieler(Spieler,Spielfeld),
	member(spieler(_,Spieler,BurgenVorher),Spielfeld),
	ritter_auf_feld_legen(Farbe1,Feld1,Spielfeld,Spielfeld2),
	ritter_auf_feld_legen(Farbe2,Feld2,Spielfeld2,Spielfeld3),
	ritter_auf_feld_legen(Feld2,Feld2,Spielfeld3,Spielfeld4),
	kaiser_bewegen(Schritte,Spielfeld4,Spielfeld5),
	burgen_tausch(Spielfeld5,Spielfeld6),
	member(spieler(_,Spieler,BurgenNachher),Spielfeld6),
	BurgenVorher > BurgenNachher.

%start(Spielfeld,Farbe,Feld,Schritte) :-
%	eine_neue_burg(Spielfeld,Farbe1,hof,Farbe2,hof,Farbe3,hof,Schritte).
%
dummerBotZug :-
	phase(3),
	spielfeld(Spielfeld),
	dummerBot(Spielfeld,Farbe1,Feld1,Farbe2,Feld2,Farbe3,Feld3,Schritte),
	gui_ritter_auf_feld(Farbe1,Feld1),
	gui_ritter_auf_feld(Farbe2,Feld2),
	gui_ritter_auf_feld(Farbe3,Feld3),
	gui_kaiser(Schritte),
	retractall(clipboard(_)),
	(client_spieler(_),true
	;not(client_spieler(_)),beende_zug).

dummerBotZug :-
	bietphase(_),
	writeln('biet'),
	spielfeld(Spielfeld),
	dummerBot(Spielfeld,Gebot),
	gui_gebot(Gebot).

dummerBot(Spielfeld,Farbe1,Feld1,Farbe2,Feld2,Farbe3,Feld3,Schritte) :-
	%Feld1 = Feld2,
    %    Feld2 = Feld3,
    %    Feld3 = hof,
	member(phase(3),Spielfeld),
	aktueller_spieler(Spieler,Spielfeld),
	member(spieler(_,Spieler,BurgenVorher),Spielfeld),
        findall([F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld6],
		(ritter_auf_feld_legen(F1,Fe1,Spielfeld,Spielfeld2),
		  %	  kleinergleichFarbe(F2,F1),
		 (Fe2 = Fe1; Fe2 = hof,kleinergleichFarbe(F3,F2)),
		 ritter_auf_feld_legen(F2,Fe2,Spielfeld2,Spielfeld3),
		 (Fe3 = hof;Fe3 = Fe2),
		 ritter_auf_feld_legen(F3,Fe3,Spielfeld3,Spielfeld4),
		 kaiser_bewegen(Schr,Spielfeld4,Spielfeld5),
		 burgen_tausch(Spielfeld5,Spielfeld6)),
		SpielfeldListe),

	%die meisten gewonnenen burgen
	mehrBurgen(Spieler,SpielfeldListe,BurgenListe,BurgAnzahl),
	minimum(BurgAnzahl,MinBurgen),
	filter1El(MinBurgen,BurgenListe,FilterListe),
	BurgenNachher is BurgenVorher-MinBurgen,

	%am besten gemerget
	anzahlFelder(FilterListe,FelderListe,FelderAnzahl),
        (BurgenNachher > 0->minimum(FelderAnzahl,FilterFeld);
	BurgenNachher =< 0->maximum(FelderAnzahl,FilterFeld)),
	filter1El(FilterFeld,FelderListe,FilterListe2),

	%am wenigsten gegnerburgen
	gegnerBurgen(Spieler,FilterListe2,BurgListe,GegBurgAnzahl),
	minimum(GegBurgAnzahl,BurgMin),
	filter1El(BurgMin,BurgListe,FilterListe3),

	%am meisten Mehrheiten
	mehrMehr(Spieler,FilterListe3,MehrListe,MehrAnzahl),
	maximum(MehrAnzahl,MaxMehr),
	filter1El(MaxMehr,MehrListe,FilterListe4),

	%am meisten Zuege mit hof
	hofZuege(FilterListe4,HofListe,HofAnzahl),
	maximum(HofAnzahl,MaxHof),
	filter1El(MaxHof,HofListe,FilterListe5),

	%die meisten Ritter auf dem Hof der Farbe mit den meisten Ritter auf dem Feld
	maxFarbe(MaxFarbe,Spielfeld),
	ritterFeld(MaxFarbe,Spieler,FilterListe5,RitterListe,RitterZahlen),
	maximum(RitterZahlen,MaxRitter),
	filter1El(MaxRitter,RitterListe,FilterListe6),

	%ritter auf reserve am besten verteilt
	verteilung(Spieler,FilterListe6,VertListe,Verteilung),
	minimum(Verteilung,MinVert),
	filter1El(MinVert,VertListe,FilterListe7),

	length(FilterListe7,Length),
	random(0,Length,Index),
	nth0(Index,FilterListe7,X),
        X = [Farbe1,Feld1,Farbe2,Feld2,Farbe3,Feld3,Schritte,_].
%member([Farbe1,Feld1,Farbe2,Feld2,Farbe3,Feld3,Schritte,_],FilterListe7).
dummerBot(Spielfeld,Gebot) :-
	aktueller_spieler(Spieler,Spielfeld),
%	member(bietphase(Biet),Spielfeld),
%	length(Biet,Phasen),
%	GebotNr is 4-Phasen,
	kaiser(Feld),
	feld(Feld,_,Nachf),
	findall(Gebote,kann_bieten(Spieler,Gebote,Spielfeld),Liste),
	(select(1,Liste,Liste2),
	 member(burgen(Nachf,Spieler,X),Spielfeld),
	 X>0
	;select(1,Liste,[]),
	 Liste = Liste2
	;member(1,Liste),
	 member(feld(Nachf,Feld,NachNach),Spielfeld),
	 member(burgen(NachNach,Spieler,X),Spielfeld),
	 X>0,
	 Liste2 = [1]
	;(not(member(1,Liste));not(member(burgen(Nachf,Spieler,_),Spielfeld))),
	 Liste = Liste2),

	length(Liste2,Length),
	random(0,Length,Index),
	nth0(Index,Liste2,Gebot).

%filter_gebot(GebotNr,KaiserFeld,Spielfeld,GeboteRein,GeboteRaus)
/*
filter_gebot(_,_,_,[],[]).
filter_gebot(1,Kaiser,Spielfeld,[1|R],[1|S]).
filter_gebot(1,Kaiser,Spielfeld,[1|R],S).
filter_gebot(1,Kaiser,Spielfeld,[2|R],[2|S]).
filter_gebot(1,Kaiser,Spielfeld,[2|R],S).
filter_gebot(1,Kaiser,Spielfeld,[3|R],[3|S]).
filter_gebot(1,Kaiser,Spielfeld,[3|R],S).
filter_gebot(1,Kaiser,Spielfeld,[4|R],[4|S]).
filter_gebot(1,Kaiser,Spielfeld,[4|R],S).
filter_gebot(1,Kaiser,Spielfeld,[5|R],[5|S]).
filter_gebot(1,Kaiser,Spielfeld,[5|R],S).
filter_gebot(2,Kaiser,Spielfeld,[1|R],[1|S]).
filter_gebot(2,Kaiser,Spielfeld,[1|R],S).
filter_gebot(2,Kaiser,Spielfeld,[2|R],[2|S]).
filter_gebot(2,Kaiser,Spielfeld,[2|R],S).
filter_gebot(2,Kaiser,Spielfeld,[3|R],[3|S]).
filter_gebot(2,Kaiser,Spielfeld,[3|R],S).
filter_gebot(2,Kaiser,Spielfeld,[4|R],[4|S]).
filter_gebot(2,Kaiser,Spielfeld,[4|R],S).
filter_gebot(2,Kaiser,Spielfeld,[5|R],[5|S]).
filter_gebot(2,Kaiser,Spielfeld,[5|R],S).
filter_gebot(3,Kaiser,Spielfeld,[1|R],[1|S]).
filter_gebot(3,Kaiser,Spielfeld,[1|R],S).
filter_gebot(3,Kaiser,Spielfeld,[2|R],[2|S]).
filter_gebot(3,Kaiser,Spielfeld,[2|R],S).
filter_gebot(3,Kaiser,Spielfeld,[3|R],[3|S]).
filter_gebot(3,Kaiser,Spielfeld,[3|R],S).
filter_gebot(3,Kaiser,Spielfeld,[4|R],[4|S]).
filter_gebot(3,Kaiser,Spielfeld,[4|R],S).
filter_gebot(3,Kaiser,Spielfeld,[5|R],[5|S]).
filter_gebot(3,Kaiser,Spielfeld,[5|R],S).
*/






%[[Farbe1,Farbe2,Farbe3,Schritte,_]|_]
maximum(Liste,Max) :-
	maximum(Liste,0,Max).

maximum([],Max,Max).
maximum([El|R],Res,Max) :-
	El =< Res,
	maximum(R,Res,Max).
maximum([El|R],Res,Max) :-
	El > Res,
	maximum(R,El,Max).

minimum([El|R],Min) :-
	minimum(R,El,Min).

minimum([],Min,Min).
minimum([El|R],Res,Min) :-
	El >= Res,
	minimum(R,Res,Min).
minimum([El|R],Res,Min) :-
	El < Res,
	minimum(R,El,Min).

verteilung(_,[],[],[]).
verteilung(Spieler,[[F1,Fe1,F2,Fe2,F3,Fe3,Schritte,Spielfeld]|R],[[Vert,F1,Fe1,F2,Fe2,F3,Fe3,Schritte,Spielfeld]|S],[Vert|T]) :-
	member(reserve_ritter(Spieler,Rot,Gr,Ge,Bl,Pi),Spielfeld),
	sumlist([Rot,Gr,Ge,Bl,Pi],Summe),
	Durch is Summe/5,
	RoA is abs(Durch-Rot),
	GrA is abs(Durch-Gr),
	GeA is abs(Durch-Ge),
	BlA is abs(Durch-Bl),
	PiA is abs(Durch-Bl),
	sumlist([RoA,GrA,GeA,BlA,PiA],Vert),
	verteilung(Spieler,R,S,T).




mehrBurgen(_,[],[],[]).
%mehrBurgen(BurgenVorher,Spieler,[[_,_,_,_,_,_,_,Spielfeld]|R],Liste,BurgList) :-
%	member(spieler(_,Spieler,Burgen),Spielfeld),
%	Burgen > BurgenVorher,
%	mehrBurgen(BurgenVorher,Spieler,R,Liste,BurgList).
mehrBurgen(Spieler,[[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[[Burgen,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[Burgen|T]):-
	member(spieler(_,Spieler,Burgen),Spielfeld),
	mehrBurgen(Spieler,R,S,T).

anzahlFelder([],[],[]).
anzahlFelder([[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[[AnzahlFelder,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[AnzahlFelder|T]) :-
	findall(1,member(feld(_,_,_),Spielfeld),Liste),
	length(Liste,AnzahlFelder),
	anzahlFelder(S,R,T).

mehrMehr(_,[],[],[]).
mehrMehr(Spieler,[[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[[Mehrheiten,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[Mehrheiten|T]) :-
	findall(1,member(mehrheit(_,Spieler),Spielfeld),Liste),
	length(Liste,Mehrheiten),
	mehrMehr(Spieler,S,R,T).


gegnerBurgen(_,[],[],[]).
gegnerBurgen(Spieler,[[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[[Gegner,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[Gegner|T]) :-
	findall(Burgen,(member(spieler(_,S2,VBurgen),Spielfeld),Spieler \= S2,Burgen is 8-VBurgen),Liste),
	sumlist(Liste,Gegner),
	gegnerBurgen(Spieler,S,R,T).

hofZuege([],[],[]).
hofZuege([[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[[Length,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[Length|T]) :-
	findall(1,(Fe1 = 'hof';
		  Fe2 = 'hof';
		  Fe3 = 'hof'
		  ),Liste),
	length(Liste,Length),
	hofZuege(S,R,T).


ritterFeld(_,_,[],[],[]).
ritterFeld(Farbe,Spieler,[[F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|S],[[Res,F1,Fe1,F2,Fe2,F3,Fe3,Schr,Spielfeld]|R],[Res|T]) :-
	farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
	member(ritter_gesetzt(Spieler,Ro,Gr,Ge,Bl,Pi),Spielfeld),
	Ro2 is Ro*Ro1,
	Gr2 is Gr*Gr1,
	Ge2 is Ge*Ge1,
	Bl2 is Bl*Bl1,
	Pi2 is Pi*Pi1,
	sumlist([Ro2,Gr2,Ge2,Bl2,Pi2],Res),
	ritterFeld(Farbe,Spieler,S,R,T).

maxFarbe(MaxFarbe,Spielfeld) :-
	findall([Summe2,Farbe],(farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
				findall(Summe1,(member(ritter_auf_feld(_,Ro,Gr,Ge,Bl,Pi),Spielfeld),
						Ro2 is Ro*Ro1,
						Gr2 is Gr*Gr1,
						Ge2 is Ge*Ge1,
						Bl2 is Bl*Bl1,
						Pi2 is Pi*Pi1,
						sumlist([Ro2,Gr2,Ge2,Bl2,Pi2],Summe1)),
					Liste1),
			       sumlist(Liste1,Summe2)),
		Liste),
	zwElweg(Liste,Liste2),
	maximum(Liste2,Max),
	filter1El(Max,Liste,Liste3),
	flatten(Liste3,Liste4),
	length(Liste4,Length),
	random(0,Length,Index),
	nth0(Index,Liste4,MaxFarbe).
%	member(MaxFarbe,Liste4).

zwElweg([],[]).
zwElweg([[A,_]|S],[A|R]) :-
	zwElweg(S,R).

filter1El(_,[],[]).
filter1El(El,[[El|Element]|S],[Element|R]):-
	filter1El(El,S,R).
filter1El(El,[[NichtEl|_]|S],Liste):-
	El \= NichtEl,
	filter1El(El,S,Liste).
