:- [anzeige],[initialisierung].
%:- starte_bietphase.
%
%
:- dynamic spielfeld/1.
%BIETEN
start :- bietphase_go.

bietphase_go :-
	bietphase([_|_]),
	write_spielfeld,
	gebot_anfordern_und_eintragen,
	bietphase_go.
bietphase_go :-
	not(bietphase(_)),
	ziehphase([_,_|_]),
	zugphase.

%Bieten
% gebot_anfordern_und_eintragen
% Zyklus f�r einen Spieler
%

gebot_anfordern_und_eintragen :-
	bietphase([_|_]),
	gebot_anfordern(Gebot),
	spielfeld(X),
	gebot_eingeben(Gebot,X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)),
	gebot_anfordern_und_eintragen.
%gebot_anfordern_und_eintragen :-
%	not(bietphase(_)).
% gebot_anfordern_und_eintragen(_).

% gebot_anfordern(+Spieler,?Gebot)
% Versucht die Eingabe des Benutzers zu lesen
gebot_anfordern(Gebot) :-
  aktueller_spieler(Spieler),
  repeat, write('Spieler '), write(Spieler), write(' Gebot abgeben: '),
  get_single_char(Char),
  Gebot is Char - 48,
  ( between(1,5,Gebot) ->
          write(Gebot), ! ;
          write(Char), nl, fail),
  nl, !.



%ZIEHEN
zugphase :-
	phase(X),
	X > 0,
	write_spielfeld,
	nl,
	zug,
	zugphase.

zugphase :-
	phase(0),
	write_spielfeld,
	nl,
	kaiser_fragen,
	zugphase.
zugphase :-
	phase(-1),
	spielfeld(X),
	burgen_tausch(X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)),

	zugphase.
zugphase :-
	phase(-2),
	spielfeld(X),
	drei_ritter_nachziehen(X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)),
	nl,
	zugphase.
zugphase :-
	phase(-3),
	spielfeld(X),
	zieh_ende(X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)),
	zugphase.

zugphase :-
	not(phase(_)),
	gewinner(X),
	write_spielfeld,
	writeln('Gewinner ist:'),
	writeln(X).
zugphase :-
	not(phase(_)),
	not(gewinner(_)),
	bietphase_go.


zug :-  repeat,
	writeln('Farbe des zu legenden Ritters?'),
	read(Farbe),
	writeln('Auf welches Feld(Zahl) oder Hof(hof)?'),
	read(Feld),
	spielfeld(X),
        ritter_auf_feld_legen(Farbe,Feld,X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)).

kaiser_fragen :-
    repeat,
    writeln('Schritte?'),
    write('Maximal '),
    aktueller_spieler(Spieler),
    aktuelles_gebot(Spieler,Gebot),
    write(Gebot),
    writeln(' Schritte!'),
    read(Schritte),
    spielfeld(X),
    kaiser_bewegen(Schritte,X,Y),
    retract(spielfeld(X)),
    assert(spielfeld(Y)).
